﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace ArchitectShack.BinarySerializationAnalysis
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //create a new Dummy Class
            DummyClass test = new DummyClass();

            //set some properties
            test.someList = new List<int>();
            test.someList.Add(1);
            test.someList.Add(2);
            test.someList.Add(3);
            test.someString = "Some Value";

            //set up a recursive reference
            test.subObject = test;

            //serialize the object to a new memory stream
            System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
            Stream stream = new MemoryStream();
            formatter.Serialize(stream, test);

            //reset the stream to the start
            stream.Position = 0;

            //analyse the binary serialization stream
            BinarySerializationStreamAnalyzer analyzer = new BinarySerializationStreamAnalyzer();
            analyzer.Read(stream);

            //display the results in the textbox
            textBox1.Text = analyzer.Analyze();

            //get rid of the stream
            stream.Dispose();

        }
    }
}
